]> git.treefish.org Git - backmeupscotty.git/commitdiff
Made everything a bit different.
authorRegina Kleinhappel <regina@treefish.org>
Tue, 29 Jul 2014 20:54:10 +0000 (22:54 +0200)
committerRegina Kleinhappel <regina@treefish.org>
Tue, 29 Jul 2014 20:54:10 +0000 (22:54 +0200)
backmeupscotty
backmeupscotty-example

index 7a76c15468e6fe0c0b49197e028c279e5c572c36..ed41ae2b5a584e03906f3f25d73f92f61d056260 100644 (file)
@@ -1,7 +1,7 @@
 #!/bin/bash
 
 REMOTE_HOST=localhost
-REMOTE_BASE=/tmp/backmeupscotty
+REMOTE_DIR=/tmp/backmeupscotty/test
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
 BACKUP_RUNEVERYNTHDAY=1
@@ -35,11 +35,11 @@ while getopts "qn:" opt; do
 done
 
 function grepbackups {
-    ssh $REMOTE_HOST "ls $REMOTE_BASE/$1" | grep -E '[0-9]+-[0-9]+'
+    ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
 }
 
 function isIncomplete {
-    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_BASE/$1/incomplete' ]' ); then
+    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
        return 0
     else
        return 1
@@ -47,47 +47,46 @@ function isIncomplete {
 }
 
 function isIncompleteOrNthDay {
-    if isIncomplete $1 || \
+    if isIncomplete || \
        [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
     then
        return 0
     else
        return 1
-    fi
-       
+    fi 
 }
 
 function scottysync {
     timestamp=$(date +%s)
 
-    scottyinfo Syncing $1 to $REMOTE_HOST:$REMOTE_BASE/$2 @$timestamp
+    scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
 
-    if [ ! -d "$1" ]; then
-       scottyerror Source dir $1 does not exist. Not syncing!
+    if [ ! -d "$SYNC_SRC" ]; then
+       scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
        return 1
     fi
 
-    if [ $(ls -A "$1" | wc -l) -eq 0 ]; then
-       scottyerror Source dir $1 is empty. Not syncing!
+    if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
+       scottyerror Source dir $SYNC_SRC is empty. Not syncing!
        return 1
     fi
 
-    dir_current=$REMOTE_BASE/$2/current
-    dir_incomplete=$REMOTE_BASE/$2/incomplete
-    dir_timestamped=$REMOTE_BASE/$2/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
+    dir_current=$REMOTE_DIR/current
+    dir_incomplete=$REMOTE_DIR/incomplete
+    dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
 
-    if [ -z $3 ]; then
+    if [ -z $SYNC_EXC ]; then
        rsync_exclude=""
     else
-       rsync_exclude=$(eval echo --exclude={$3} | tr -d {})
+       rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
-    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_BASE/$2' ]'); then
-       scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_BASE/$2
-       ssh $REMOTE_HOST "mkdir $REMOTE_BASE/$2"
+    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+       scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
+       ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
-    if isIncomplete $2; then
+    if isIncomplete; then
        scottyerror Continuing old incomplete backup
     fi
 
@@ -96,7 +95,7 @@ function scottysync {
        -v -aHAX --numeric-ids --delete --delete-excluded \
        --link-dest=$dir_current \
        $rsync_exclude \
-       $1/ $REMOTE_HOST:$dir_incomplete/
+       $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
     
     if [ $? -eq 0 ]; then
        scottyinfo Timestamping completed backup and linking to current backup
@@ -104,15 +103,64 @@ function scottysync {
            "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
     fi
 
-    while [ $(grepbackups $2 | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
-       oldestbackup=$(grepbackups $2 | head -1)
+    while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
+       oldestbackup=$(grepbackups | head -1)
        oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
            scottyinfo Removing old backup $oldestbackup
-           ssh $REMOTE_HOST rm -r "$REMOTE_BASE/$2/$oldestbackup"
+           ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
        else
            break
        fi
     done
 }
+
+function prepare {
+    scottyinfo "Preparing for sync"
+}
+
+function cleanup_abrt {
+    scottyinfo "No cleanup_abrt function was defined."
+}
+
+function _cleanup_abrt {
+    scottyerror "Caught exit signal! Cleaning up..."
+    cleanup_abrt
+    if [ $(jobs -p) ]; then
+       scottyerror TERMinating remaining child processes...
+       kill $(jobs -p)
+    fi
+    exit
+}
+
+function prepare {
+    scottyinfo "No prepare function was defined."
+}
+
+function _prepare {
+    prepare
+}
+
+function cleanup_normal {
+    scottyinfo "No cleanup_normal function was defined."
+}
+
+function _cleanup_normal {
+    cleanup_normal
+}
+
+function backmeupscotty {
+    if ! isIncompleteOrNthDay; then
+       scottyinfo "This is not the nth day and no incomplete backup exists."
+       exit 0
+    fi
+
+    trap _cleanup_abrt EXIT
+
+    _prepare
+    scottysync
+    _cleanup_normal
+
+    trap - EXIT
+}
index c49e2adb76d6c00eeb0a90531b9d10994de2be3d..b9acea7c639202dbefc444e137af0c16d699a3c0 100755 (executable)
@@ -3,14 +3,11 @@
 . ./backmeupscotty
 
 REMOTE_HOST=localhost
-REMOTE_BASE=/home/alex/backtest
-ARCHIVE_KEEPNBACKUPS=30
-ARCHIVE_KEEPNDAYS=1
-
-if ! isIncompleteOrNthDay dest; then
-    scottyinfo "This is not the nth day and no incomplete backup exists."
-    exit 0
-fi
-
-scottysync /home/alex/backtest/source dest "/gack,/gugu/*"
-scottysync /home/alex/backtest/source2 dest2
+REMOTE_DIR=/home/regina/backtest/dest
+ARCHIVE_KEEPNBACKUPS=10
+ARCHIVE_KEEPNDAYS=0
+BACKUP_RUNEVERYNTHDAY=1
+SYNC_SRC="/home/regina/backtest/source"
+SYNC_EXC="/gack,/gugu/*"
+
+backmeupscotty